﻿#region Copyright Syncfusion Inc. 2001 - 2011
// Copyright Syncfusion Inc. 2001 - 2011. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Syncfusion.Windows.Controls.Grid;
using Syncfusion.Windows.Controls.Cells;
using System.Diagnostics;

namespace StackedHeadersDemo
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {        
        public Window1()
        {
            InitializeComponent();
            dataGrid.Loaded += new RoutedEventHandler(dataGrid_Loaded);
        }
        public Dictionary<int, double> ResolveColumnWidthsFromSHColumn(int shColumnIndex)
        {
            Dictionary<int, double> tempColIndexWidth = new Dictionary<int, double>();
            int totalVisibleColumns = this.dataGrid.VisibleColumns.Count;
            int tempCol = 0;
            int i = 0;
            foreach (GridDataStackedHeaderColumn shColumn in dataGrid.StackedHeaderRows[0].Columns)
            {
                if (i == shColumnIndex)
                {
                    int startColumn = tempCol;
                    int endColumn = startColumn + shColumn.ColumnSpan - 1;
                    for (int j = 0; j < this.dataGrid.VisibleColumns.Count; j++)
                    {
                        if (j >= startColumn && j <= endColumn)
                        {
                            tempColIndexWidth.Add(j, this.dataGrid.Model.ColumnWidths[j]);
                        }
                    }
                }
                tempCol = tempCol + shColumn.ColumnSpan;
                i++;
            }
            return tempColIndexWidth;
        }

        public int GetStackedHeaderColumnIndex(int columnIndex)
        {
            int columnSpan = 0;
            int index = 0;
            foreach (GridDataStackedHeaderColumn shColumn in dataGrid.StackedHeaderRows[0].Columns)
            {
                columnSpan = columnSpan + shColumn.ColumnSpan;
                if (columnIndex < columnSpan)
                {
                    return index;
                }
                index++;
            }
            return -1;
        }

        void dataGrid_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (GridDataVisibleColumn vc in this.dataGrid.VisibleColumns)
            {
                double minWidth = 200;
                var columnIndex = this.dataGrid.VisibleColumns.IndexOf(vc);
                Dictionary<int, double> ColIndexWidthCollection = new Dictionary<int, double>();
                int shColumnIndex = this.GetStackedHeaderColumnIndex(columnIndex);
                ColIndexWidthCollection = this.ResolveColumnWidthsFromSHColumn(shColumnIndex);
                double shWidth = ColIndexWidthCollection.Sum(i => i.Value);
                if (shWidth < minWidth)
                {
                    double laggingWidth = minWidth - shWidth;
                    dataGrid.Model.ColumnWidths[columnIndex] = dataGrid.Model.ColumnWidths[columnIndex] + laggingWidth + 0.1;
                    ColIndexWidthCollection = this.ResolveColumnWidthsFromSHColumn(shColumnIndex);
                    shWidth = ColIndexWidthCollection.Sum(i => i.Value);
                }
            }            
        }
    }
}
